package com.example.blum.horseracing2;

import android.content.res.XmlResourceParser;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

public class MainActivity extends AppCompatActivity {

    List<Horse> myList = new ArrayList<Horse>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        final TextView tvSire = (TextView) findViewById(R.id.tvSire);
        final TextView tvTrainer = (TextView) findViewById(R.id.tvTrainer);
        final ImageView ivSilks = (ImageView) findViewById(R.id.ivSilks);

        try{
            //http://stackoverflow.com/questions/6420293/reading-android-raw-text-file
           // InputStream is = getResources().openRawResource(R.raw.horseracing);
           // byte[] buffer = new byte[is.available()];
           // while (is.read(buffer) != -1);

            //String myText = new String(buffer);
            //Toast.makeText(getBaseContext(), myText, Toast.LENGTH_LONG).show();


            List<String> horsenames = new ArrayList<String>();

            XmlPullParser parser = getResources().getXml(R.xml.horseracing);
            int eventType=-1;
            int myIndex=-1;


            while(eventType!=XmlResourceParser.END_DOCUMENT){
                if(eventType==XmlResourceParser.START_TAG){
                    String tagName = parser.getName();
                    //Toast.makeText(getBaseContext(), tagName, Toast.LENGTH_LONG).show();
                    switch (tagName){
                        case "element":  //starts a new horse
                            myList.add(new Horse());
                            myIndex++;
                            break;
                        case "horseJockey":
                            parser.next();  //move to text
                            ((Horse) myList.get(myIndex)).jockey = parser.getText();
                            //Toast.makeText(getBaseContext(), parser.getText(), Toast.LENGTH_LONG).show();
                            parser.next();   //move to end tag
                            break;
                        case "horseName":
                            parser.next();
                            ((Horse) myList.get(myIndex)).horseName = parser.getText();
                            horsenames.add(parser.getText());
                            parser.next();
                            break;
                        case "horseRank":
                            parser.next();
                            ((Horse) myList.get(myIndex)).rank = Integer.parseInt(parser.getText());
                            parser.next();
                            break;
                        case "horseRating":
                            parser.next();
                            ((Horse) myList.get(myIndex)).rating = Double.parseDouble(parser.getText());
                            parser.next();
                            break;
                        case "horseSilks":
                            parser.next();  //move to text
                            ((Horse) myList.get(myIndex)).silks = parser.getText();

                            parser.next();   //move to end tag
                            break;
                        case "horseSire":
                            parser.next();  //move to text
                            ((Horse) myList.get(myIndex)).sire = parser.getText();
                            parser.next();   //move to end tag
                            break;
                        case "horseTrainer":
                            parser.next();  //move to text
                            ((Horse) myList.get(myIndex)).trainer = parser.getText();
                            parser.next();   //move to end tag
                            break;
                    }
                }
                eventType = parser.next();
            }

/*
            while (eventType != XmlPullParser.END_DOCUMENT) {
                if(eventType == XmlPullParser.START_DOCUMENT) {
                    System.out.println("Start document");
                } else if(eventType == XmlPullParser.END_DOCUMENT) {
                    System.out.println("End document");
                } else if(eventType == XmlPullParser.START_TAG) {
                    System.out.println("Start tag "+parser.getName());
                } else if(eventType == XmlPullParser.END_TAG) {
                    System.out.println("End tag "+parser.getName());
                } else if(eventType == XmlPullParser.TEXT) {
                    System.out.println("Text "+parser.getText());
                }
                eventType = parser.next();
            }
*/

            //associate the full name with the listView
            Spinner spHorse = (Spinner) findViewById(R.id.spHorse);


            ArrayAdapter<String> aaHorse = new ArrayAdapter<String>(this,   android.R.layout.simple_spinner_item, horsenames);
            aaHorse.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item); // The drop down view
            spHorse.setAdapter(aaHorse);

            spHorse.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                @Override
                public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                    tvSire.setText( myList.get(i).sire );
                    tvTrainer.setText(myList.get(i).trainer);

                    int iv_id = getResources().getIdentifier(myList.get(i).silks, "drawable",
                            getPackageName());
                    ivSilks.setImageResource(iv_id);
                }

                @Override
                public void onNothingSelected(AdapterView<?> adapterView) {

                }
            });


        }
        catch(XmlPullParserException e){
            Toast.makeText(getBaseContext(), "Problem XML parsing problem", Toast.LENGTH_LONG).show();
        }
        catch(Exception e){
            Toast.makeText(getBaseContext(), "Problem with file", Toast.LENGTH_LONG).show();
            e.printStackTrace();
        }

    }//end onCreate
}//end MainActivity
